package com.lo53_mobile_localization.core.service;

import com.lo53_mobile_localization.core.entity.IEntity;

import java.util.List;

/**
 * Created by Thomas on 10/05/2017.
 */
public interface IService {

    /**
     * To store an entity
     * @param entity
     */
    void storeEntity(IEntity entity);

    /**
     * To update an entity
     * @param id
     * @param entity
     */
    void updateEntity(int id, final IEntity entity) throws Exception;

    /**
     * To remove an entity
     * @param id
     */
    void removeEntity(int id) throws Exception;

    /**
     * To get an entity by his id
     * @param id
     * @return
     */
    IEntity getEntity(int id) throws Exception;

    /**
     * To get the list of entities
     * @return
     */
    List getEntities() throws Exception;
}
