package com.lo53_mobile_localization.core.service;

import com.lo53_mobile_localization.core.entity.IEntity;
import com.lo53_mobile_localization.core.entity.Location;
import com.lo53_mobile_localization.core.repository.LocationDAO;
import com.lo53_mobile_localization.core.util.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.query.Query;

import java.util.List;

/**
 * Created by Thomas on 10/05/2017.
 */
public class LocationService implements IService {


    protected LocationDAO locationDAO;

    public LocationService(){
        this.locationDAO = new LocationDAO();
    }

    public void storeEntity(IEntity entity) {
        this.locationDAO.insertEntity((Location) entity);
    }

    public void updateEntity(int id, IEntity entity) throws Exception {
        this.locationDAO.updateEntity(id, (Location) entity);
    }

    public void removeEntity(int id) throws Exception {
        this.locationDAO.removeEntity(id);
    }

    public IEntity getEntity(int id) throws Exception {
        return this.locationDAO.getEntity(id);
    }

    public List getEntities() throws Exception {
        return this.locationDAO.getEntities();
    }

    public Location getLocationFromCoordinates(double x, double y){

        Session session = HibernateUtil.getSession();
        session.beginTransaction();

        String hql= "from " + Location.class.getCanonicalName() + " l where l.x = :x and l.y = :y";

        Query query = session.createQuery(hql);
        query.setParameter("x", x);
        query.setParameter("y",y);

        Location result = (Location) query.getSingleResult();

        return result;
    }
}
