package com.lo53_mobile_localization.core.servlet;

import com.lo53_mobile_localization.core.servlet.util.Param;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by Thomas on 03/06/2017.
 */
@WebServlet(
        name = "PreferencesServlet",
        urlPatterns = {"/preferences"}
)
public class PreferencesServlet extends HttpServlet {

    /**
	 * 
	 */
	private static final long serialVersionUID = -3145241745179875121L;

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
        response.setContentType(Param.CONTENT_TYPE);
        request.getRequestDispatcher(Param.PATH_PREFERENCES).forward(request,response);

    }

    public void doPost(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {

        response.setContentType(Param.CONTENT_TYPE);

        String ip = request.getParameter(Param.ATTRIBUTE_IP);
        String port = request.getParameter(Param.ATTRIBUTE_PORT);

        String IP_PATTERN = "^([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\."
                + "([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\."
                + "([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\."
                + "([01]?\\d\\d?|2[0-4]\\d|25[0-5])$";

       // String MAC_PATTERN = "^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$";

        String PORT_PATTERN = "[0-6][0-9]{3}";

        Pattern patternIP = Pattern.compile(IP_PATTERN);
        Matcher matchIp = patternIP.matcher(ip);

        Pattern patternPort = Pattern.compile(PORT_PATTERN);
        Matcher matchPort = patternPort.matcher(port);

        if (!matchIp.find() || !matchPort.find()) {
            System.out.println("ERROR IN SETTINGS");
            request.setAttribute("message", "ERROR IN ONE OF THE FIELDS");
            request.getRequestDispatcher(Param.PATH_PREFERENCES).forward(request, response);

        } else {

            System.out.println(" IP = " + ip + "   PORT = " + port);

            getServletContext().setAttribute("ip", ip);
            getServletContext().setAttribute("port", port);

            request.getRequestDispatcher(Param.PATH_HOME).forward(request, response);
        }
    }

}
