<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<!DOCTYPE html>
<html>
<head>
    <link rel="stylesheet" href="../css/bootstrap.min.css"/>
    <script src="../js/jquery-3.1.1.min.js"></script>
    <script type="text/javascript" src="../js/bootstrap.min.js"></script>
    <title>Calibration</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>
<body>
<div class="container">

    <canvas id="myCanvas" width="200" height="200" style="border:1px solid #000000;">
    </canvas>

    <form action ="${pageContext.request.contextPath}/calibration" method="post">
        <br/>
        <input type="hidden" name="positionX" id="positionXId" value="-1"/>
        <input type="hidden" name="positionY" id="positionYId" value = "-1"/>
        <button type="submit" class="btn btn-primary  btn-md">Calibrate</button>
    </form>

    <SCRIPT LANGUAGE="JavaScript">

        var canvas = document.getElementById('myCanvas');
        var context = canvas.getContext('2d');

        var rdc = new Image();
        rdc.src = "./fonts/H_RDC.png"
        rdc.onload = function(){
            context.drawImage(rdc, 0, 0, canvas.width, canvas.height);
        }

        function writeMessage(canvas, message, x, y) {
            context.clearRect(0,0, canvas.width, canvas.height)
            context.font = '10pt Calibri';
            context.fillStyle = 'black';
            context.drawImage(rdc, 0, 0, canvas.width, canvas.height);
            context.fillText(message, 10, 15);
            context.fillRect(x,y,3,3);
        }

        function getMousePos(canvas, evt) {
            var rect = canvas.getBoundingClientRect();
            return {
                x: evt.clientX - rect.left,
                y: evt.clientY - rect.top
            };
        }

        canvas.addEventListener('click', function(evt) {
            var mousePos = getMousePos(canvas, evt);
            var message = '(' + mousePos.x + ',' + mousePos.y + ')';

            writeMessage(canvas, message, mousePos.x, mousePos.y);

            document.getElementById("positionXId").value = mousePos.x;
            document.getElementById("positionYId").value = mousePos.y;

        }, false);

    </SCRIPT>
</div>
</body>
</html>