package com.lo53_mobile_localization.core.helpers;

import com.lo53_mobile_localization.core.util.HibernateUtil;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
import org.junit.After;
import org.junit.Before;

/**
 * Created by Thomas on 10/05/2017.
 */
public class HibernateTestHelper {

    @Before
    public void setUp() throws Exception {
        Configuration configuration = createTestingConfiguration();

        SessionFactory sessionFactory = configuration.buildSessionFactory();
        HibernateUtil.setSessionFactory(sessionFactory);
    }


    protected Configuration createTestingConfiguration() {
        Configuration configuration = new Configuration();
        configuration.configure();

        configuration.setProperty("hibernate.dialect", "org.hibernate.dialect.PostgreSQL82Dialect");
        configuration.setProperty("hibernate.connection.driver_class", "org.postgresql.Driver");
        configuration.setProperty("hibernate.connection.username", "postgres");
        configuration.setProperty("hibernate.connection.password", "");
        configuration.setProperty("hibernate.connection.url", "jdbc:postgresql://localhost:5432/postgres");
        configuration.setProperty("hibernate.hbm2ddl.auto", "create");

        return configuration;
    }

    @After
    public void tearDown() throws Exception {
        if(HibernateUtil.getSession().isOpen())
            HibernateUtil.getSession().close();
    }

}
